/*
	Code generation for the following grammar segment:

	BindDeclaration := "at" "(" Expression ["," Expression "," Expression] ")"
*/


package salsa_lite.core.compiler.definitions;

import salsa_lite.core.compiler.SalsaParser;
import salsa_lite.core.compiler.SimpleNode;

public class BindDeclaration extends SimpleNode {

	public BindDeclaration(int id) 			{ super(id); }
	public BindDeclaration(SalsaParser p, int id)	{ super(p, id); }

	public String getUAN() {
		return getChild(0).getJavaCode();
	}

	public String getHost() {
		if (children.length > 1) {
			return getChild(1).getJavaCode();
		} else {
			return "null";
		}
	}

	public String getPort() {
		if (children.length > 1) {
			return getChild(2).getJavaCode();
		} else {
			return "-1";
		}
	}

	public String getJavaCode() {
		String code = getChild(0).getJavaCode();
		if (children.length > 1) code += ", " + getChild(1).getJavaCode();
		return code;
	}
}
