/*
	Code generation for the following grammar segment:
	
	InterfaceBody :=
	"{" 
		(
			| StateVariableDeclaration
			| MethodLookahead ";"
		)* 
	"}"
*/

package salsa_lite.core.compiler.definitions;

import salsa_lite.core.compiler.SalsaCompiler;
import salsa_lite.core.compiler.SalsaParser;
import salsa_lite.core.compiler.SimpleNode;


public class InterfaceBody extends SimpleNode {
	
	public InterfaceBody(int id) 			{ super(id); }
	public InterfaceBody(SalsaParser p, int id)	{ super(p, id); }

	public String getPreCode()		{
		SalsaCompiler.indent++;
		String actorName = parent.getToken(1).image;

		String code = "{\n";

		return code;
	}

	public String getPostCode()	{
		SalsaCompiler.indent--;

		String code = "}";
	
		return code;
	}
	
	public String getChildCode() {
		String code = "";

		if (children != null) {		
			for (int i = 0; i < children.length; i++) {
				code += SalsaCompiler.getIndent() + getChild(i).getJavaCode();
				if (getChild(i) instanceof MethodLookahead) code += ";\n";
			}
		}
		
		return code;
	}
}
