/*
	Code generation for the following grammar segment:
	
	InterfaceDeclaration := "interface" <IDENTIFIER> ["extends" Name()] InterfaceBody()
*/


package salsa_lite.core.compiler.definitions;

import salsa_lite.core.compiler.SalsaParser;
import salsa_lite.core.compiler.SimpleNode;

public class InterfaceDeclaration extends SimpleNode {

	public InterfaceDeclaration(int id) 			{ super(id); }
	public InterfaceDeclaration(SalsaParser p, int id)	{ super(p, id); }

	public String extendsName = null;

	public String getActorName() {
		return getToken(1).image;
	}

	public String getReferenceCode() {
		String code = "class " + getToken(1);

		int i = 2;
		if (tokens.length < 3) {
			if (System.getProperty("enable_gc") == null) {
				extendsName = "LiteActor";
				code += " extends LiteActor ";
			} else {
				extendsName = "CollectibleActor";
				code += " extends CollectibleActor ";
			}
		} else {
			extendsName = getChild(i-2).getJavaCode();
			code += " extends " + getChild(i-2).getJavaCode() + " ";
		}
		return code;
	}

	public String getChildCode() {
		String code = "interface " + getToken(1) + "State";

		int i = 2;
		if (tokens.length < 3) {
			extendsName = "Actor";
			code += " extends Actor";
			code += " " + getChild(0).getJavaCode();
		} else {
			extendsName = getChild(i-2).getJavaCode() + "State";
			code += " extends " + getChild(i-2).getJavaCode() + "State";
			code += " " + getChild(1).getJavaCode();
		}
		return code;
	}
}
