/*
	Code generation for the following grammar segment:

	MessageProperty := <IDENTIFIER> [Arguments]	
*/

package salsa_lite.core.compiler.definitions;

import salsa_lite.core.compiler.SalsaCompiler;
import salsa_lite.core.compiler.SalsaParser;
import salsa_lite.core.compiler.SimpleNode;

public class MessageProperty extends SimpleNode {

	public MessageProperty(int id)				{ super(id); }
	public MessageProperty(SalsaParser p, int id)		{ super(p, id); }

	public String getJavaCode() {
		String code = "";

		code += SalsaCompiler.getIndent() + "Object[] _propertyInfo = { ";
		if (children != null) {
			Arguments arguments = (Arguments)getChild(0);
			code += arguments.getPropertyCode();
		}
		code += " };\n";

		code += SalsaCompiler.getIndent() + "__message.setProperty( \"" + getToken(0).image + "\", _propertyInfo );\n";
		return code;
	}
}
