package salsa_lite.core.language;
import java.util.Vector;

import salsa_lite.core.language.exceptions.CurrentContinuationException;
import salsa_lite.core.language.exceptions.MessageHandlerNotFoundException;
import salsa_lite.core.naming.UAN;
import salsa_lite.core.naming.UAL;

public interface Actor {
	/********
		*	For Identification
	 ********/
	public UAN		getUAN();
	public UAL		getUAL();
	public int		hashCode();
	public String		getUniqueIdentifier();
	public ActorReference	getReference();

	/********
		*	For creation
	 ********/
	public void		setConstructMessage(Message message);
	public Message		getConstructMessage();

	/********
		*	For deletion
	 ********/
	public boolean isDestroyed();
	public void destroy();

	/********
		*	For Migration
	 ********/
	public	boolean		isMigrating();
	public	String		getMigrationHost();
	public	int		getMigrationPort();
	public	void		migrate(String host, int port);
	public	void		migrationCompleted();

	/********
		*	Message processing
	 ********/
	public void		setCurrentMessage(Message message);
	public void		handleRequiredTokens(Message message);
	public Object		invokeMessage(String methodName, Object[] arguments) throws CurrentContinuationException, MessageHandlerNotFoundException, Exception;
	public Vector<Message>	getGeneratedMessages();
}
