package examples.addressbook;

// Import declarations generated by the SALSA compiler, do not modify.
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import salsa_lite.core.language.Actor;
import salsa_lite.core.language.ActorReference;
import salsa_lite.core.language.IdentifierGenerator;
import salsa_lite.core.language.Message;

import salsa_lite.core.services.ServiceFactory;

import salsa_lite.core.language.Token;
import salsa_lite.core.language.exceptions.CurrentContinuationException;
import salsa_lite.core.language.exceptions.MessageHandlerNotFoundException;

import salsa_lite.core.language.LiteActorState;

import salsa_lite.core.naming.UAN;
import salsa_lite.core.naming.UAL;
import salsa_lite.core.naming.MalformedUALException;
import salsa_lite.core.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.


public class GetEmailState extends LiteActorState  {
	public GetEmailState(UAN uan) {
		super(uan);
		self = new GetEmail(getUAN());
	}

	public GetEmailState(UAL ual) {
		super(ual);
		self = new GetEmail(getUAL());
	}

	public GetEmailState(String identifier) {
		super(identifier);
		self = new GetEmail(getUAL());
	}

	public Object invokeMessage(String methodName, Object[] arguments) throws CurrentContinuationException, MessageHandlerNotFoundException, Exception {
		if (methodName.equals("act") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof String[])) {
			act((String[])arguments[0]);
			return null;
		}  else if (methodName.equals("getEmail") && arguments.length == 2 && (arguments[0] == null || arguments[0] instanceof String) && (arguments[1] == null || arguments[1] instanceof String)) {
			getEmail((String)arguments[0], (String)arguments[1]);
			return null;
		}  else if (methodName.equals("construct") && arguments.length == 0) {
			construct();
			return null;
		} else {
			return super.invokeMessage(methodName, arguments);
		}
	}

	void construct() {}

	public void act(String args[]) {
		this.construct();

		if (args.length!=2) {
			{
				// standardOutput<-println("Usage: java examples.addressbook.GetEmail <AddressBookUAN> <Name>")
				{
					Message __message = new Message( self, standardOutput, "println", new Object[]{ "Usage: java examples.addressbook.GetEmail <AddressBookUAN> <Name>" }, null, null);
					__messages.add( __message );
				}
			}
			return;
		}
		{
			// getEmail(args[0], args[1])
			{
				Message __message = new Message( self, self, "getEmail", new Object[]{ args[0], args[1] }, null, null);
				__messages.add( __message );
			}
		}
	}
	public void getEmail(String uan, String name) {
		try {
			AddressBook book = new AddressBook(new UAN(uan));
			{
				Token token_3_0 = new Token();
				Token token_3_1 = new Token();
				// standardOutput<-print(name+"'s email: ")
				{
					Message __message = new Message( self, standardOutput, "print", new Object[]{ name+"'s email: " }, null, token_3_0);
					__messages.add( __message );
				}
				// book<-getEmail(name)
				{
					Message __message = new Message( self, book, "getEmail", new Object[]{ name }, token_3_0, token_3_1);
					__messages.add( __message );
				}
				// standardOutput<-println(token)
				{
					Message __message = new Message( self, standardOutput, "println", new Object[]{ token_3_1 }, token_3_1, null);
					__messages.add( __message );
				}
			}
		}
		catch (MalformedUANException e) {
			{
				// standardOutput<-println(e)
				{
					Message __message = new Message( self, standardOutput, "println", new Object[]{ e }, null, null);
					__messages.add( __message );
				}
			}
		}

	}
}