package salsa_lite.examples.fibonacci;

// Import declarations generated by the SALSA compiler, do not modify.
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import salsa_lite.core.language.Actor;
import salsa_lite.core.language.ActorReference;
import salsa_lite.core.language.IdentifierGenerator;
import salsa_lite.core.language.Message;
import salsa_lite.core.language.Token;
import salsa_lite.core.language.exceptions.CurrentContinuationException;
import salsa_lite.core.language.exceptions.MessageHandlerNotFoundException;

import salsa_lite.core.language.CollectibleActorState;

import salsa_lite.core.naming.UAN;
import salsa_lite.core.naming.UAL;
import salsa_lite.core.naming.MalformedUALException;
import salsa_lite.core.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.


public class FibonacciState extends CollectibleActorState  {
	public FibonacciState(UAN uan) {
		super(uan);
		self = new Fibonacci(getUAN());
	}

	public FibonacciState(UAL ual) {
		super(ual);
		self = new Fibonacci(getUAL());
	}

	public FibonacciState(String identifier) {
		super(identifier);
		self = new Fibonacci(getUAL());
	}

	public Object invokeMessage(String methodName, Object[] arguments) throws CurrentContinuationException, MessageHandlerNotFoundException, Exception {
		if (methodName.equals("construct") && arguments.length == 1) {
			construct(((Integer)arguments[0]).intValue());
			return null;
		}  else if (methodName.equals("add") && arguments.length == 2 && (arguments[0] == null || arguments[0] instanceof Integer) && (arguments[1] == null || arguments[1] instanceof Integer)) {
			return new Integer(add(((Integer)arguments[0]).intValue(), ((Integer)arguments[1]).intValue()));
		}  else if (methodName.equals("compute") && arguments.length == 0) {
			return new Integer(compute());
		}  else if (methodName.equals("finish") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof Integer)) {
			finish(((Integer)arguments[0]).intValue());
			return null;
		}  else if (methodName.equals("act") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof String[])) {
			act((String[])arguments[0]);
			return null;
		}  else {
			return super.invokeMessage(methodName, arguments);
		}
	}

	int n;
	long start_time;
	void construct(int n){
		this.n = n;
	}
	public int add(int x, int y) {
		return x+y;
	}
	public int compute() {
		if (n==0) 		return 0;
		else if (n<=2) 		return 1;
		else {
			Fibonacci fib1 = Fibonacci.construct(self, null, null, -1, new Object[]{new Integer(n-1)}).copy();
			Fibonacci fib2 = Fibonacci.construct(self, null, null, -1, new Object[]{new Integer(n-2)}).copy();
			Token x = new Token("x");
			{
				// token x = fib1<-compute()
				{
					Message __message = new Message( self, fib1, "compute", new Object[]{  }, null, x);
					__messages.add( __message );
				}
			}
			Token y = new Token("y");
			{
				// token y = fib2<-compute()
				{
					Message __message = new Message( self, fib2, "compute", new Object[]{  }, null, y);
					__messages.add( __message );
				}
			}
			{
				// add(x, y)
				{
					Message __message = new Message( self, self.copy(), "add", new Object[]{ x, y }, null, currentMessage.getContinuationToken());
					__message.setJoinPosition(currentMessage.getJoinPosition());
					__messages.add( __message );
				}
				throw new CurrentContinuationException();
			}
		}
	}
	public void finish(int value) {
		System.out.println("fibonacci took: "+(System.currentTimeMillis()-start_time)+" milliseconds.");
		System.out.println(new Integer(value));
	}
	public void act(String[] args) {
		n = Integer.parseInt(args[0]);
		start_time = System.currentTimeMillis();
		{
			Token token_2_0 = new Token();
			// compute()
			{
				Message __message = new Message( self, self.copy(), "compute", new Object[]{  }, null, token_2_0);
				__messages.add( __message );
			}
			// finish(token)
			{
				Message __message = new Message( self, self.copy(), "finish", new Object[]{ token_2_0 }, token_2_0, null);
				__messages.add( __message );
			}
		}
	}
}