package salsa_lite.examples.mergesort;

// Import declarations generated by the SALSA compiler, do not modify.
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import salsa_lite.core.language.Actor;
import salsa_lite.core.language.ActorReference;
import salsa_lite.core.language.IdentifierGenerator;
import salsa_lite.core.language.Message;
import salsa_lite.core.language.Token;
import salsa_lite.core.language.exceptions.CurrentContinuationException;
import salsa_lite.core.language.exceptions.MessageHandlerNotFoundException;

import salsa_lite.core.language.CollectibleActorState;

import salsa_lite.core.naming.UAN;
import salsa_lite.core.naming.UAL;
import salsa_lite.core.naming.MalformedUALException;
import salsa_lite.core.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.

import java.io.FileReader;
import java.io.BufferedReader;
import java.io.IOException;
import java.util.Vector;

public class MergesortState extends CollectibleActorState  {
	public MergesortState(UAN uan) {
		super(uan);
		self = new Mergesort(getUAN());
	}

	public MergesortState(UAL ual) {
		super(ual);
		self = new Mergesort(getUAL());
	}

	public MergesortState(String identifier) {
		super(identifier);
		self = new Mergesort(getUAL());
	}

	public Object invokeMessage(String methodName, Object[] arguments) throws CurrentContinuationException, MessageHandlerNotFoundException, Exception {
		if (methodName.equals("act") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof String[])) {
			act((String[])arguments[0]);
			return null;
		}  else if (methodName.equals("distributed_start") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof String[])) {
			distributed_start((String[])arguments[0]);
			return null;
		}  else if (methodName.equals("local_start") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof String[])) {
			local_start((String[])arguments[0]);
			return null;
		}  else if (methodName.equals("mergesort") && arguments.length == 4 && (arguments[0] == null || arguments[0] instanceof Integer) && (arguments[1] == null || arguments[1] instanceof Integer) && (arguments[2] == null || arguments[2] instanceof Integer) && (arguments[3] == null || arguments[3] instanceof Mergesort[])) {
			return mergesort(((Integer)arguments[0]).intValue(), ((Integer)arguments[1]).intValue(), ((Integer)arguments[2]).intValue(), (Mergesort[])arguments[3]);
		}  else if (methodName.equals("merge") && arguments.length == 2 && (arguments[0] == null || arguments[0] instanceof double[]) && (arguments[1] == null || arguments[1] instanceof double[])) {
			return merge((double[])arguments[0], (double[])arguments[1]);
		}  else if (methodName.equals("sort") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof Integer)) {
			return sort(((Integer)arguments[0]).intValue());
		}  else if (methodName.equals("printResults") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof double[])) {
			printResults((double[])arguments[0]);
			return null;
		}  else if (methodName.equals("finish") && arguments.length == 0) {
			finish();
			return null;
		}  else if (methodName.equals("construct") && arguments.length == 0) {
			construct();
			return null;
		} else {
			return super.invokeMessage(methodName, arguments);
		}
	}

	void construct() {}

	long start_time;
	public void act(String[] arguments) {
		if (!(arguments.length==5)&&!(arguments.length==3)) {
			System.err.println("Usage:");
			System.err.println("\tjava examples.mergesort.Mergesort <#workers> <#elements> <iterations> [theater file] [nameserver]");
			System.exit(0);
		}
		if (arguments.length==5) 		{
			// distributed_start(arguments)
			{
				Message __message = new Message( self, self.copy(), "distributed_start", new Object[]{ arguments }, null, null);
				__messages.add( __message );
			}
		}
		else 		{
			// local_start(arguments)
			{
				Message __message = new Message( self, self.copy(), "local_start", new Object[]{ arguments }, null, null);
				__messages.add( __message );
			}
		}
	}
	public void distributed_start(String[] arguments) {
		int number_workers = Integer.parseInt(arguments[0]);
		int number_elements = Integer.parseInt(arguments[1]);
		int iterations = Integer.parseInt(arguments[2]);
		String theaters_file = arguments[3];
		String nameserver = arguments[4];
		Vector theaters = new Vector();
		try {
			BufferedReader in = new BufferedReader(new FileReader(theaters_file));
			String theater = in.readLine();
			while (theater!=null) {
				if (!theater.equals("")) theaters.add(theater);
				theater = in.readLine();
			}
			in.close();
		}
		catch (IOException ioe) {
			System.err.println("[error] Can't open the file "+theaters_file+" for writing.");
		}

		int workers_per_theater = (number_workers/theaters.size())+1;
		int elements_per_worker = number_elements/number_workers;
		Mergesort[] workers = new Mergesort[number_workers];
		int target_theater = 0;
		int sent_to_theater = 0;
		System.err.println("workers per theater: "+workers_per_theater);
		System.err.println("total workers: "+number_workers);
		for (int i = 0; i<number_workers; i++){
			try {
				UAN uan = new UAN("uan://"+nameserver+"/worker_"+i);
				UAL ual = new UAL("rmsp://"+theaters.get(i%theaters.size())+"/worker_"+i);
				workers[i] = Mergesort.construct(self, uan, ual.getHost(), ual.getPort(), new Object[]{}).copy();
			}
			catch (Exception e) {
				System.err.println("Error generating UAN and UAL: "+e);
				e.printStackTrace();
				System.exit(0);
			}

		}
		Token x = new Token("x");
		{
			Token token_2_0 = new Token();
			// mergesort(new Integer(0), new Integer(number_workers), new Integer(elements_per_worker), workers)
			{
				Message __message = new Message( self, self.copy(), "mergesort", new Object[]{ new Integer(0), new Integer(number_workers), new Integer(elements_per_worker), workers }, null, token_2_0);
				__messages.add( __message );
			}
			// token x = finish()
			{
				Message __message = new Message( self, self.copy(), "finish", new Object[]{  }, token_2_0, x);
				__messages.add( __message );
			}
		}
		for (int i = 0; i<iterations-1; i++){
			{
				Token token_3_0 = new Token();
				// new Integer(0)new Integer(number_workers)new Integer(elements_per_worker)workersmergesort:((x))
				{
					Message __message = new Message( self, self.copy(), "mergesort", new Object[]{ new Integer(0), new Integer(number_workers), new Integer(elements_per_worker), workers }, null, token_3_0);
					Object[] _propertyInfo = { x };
					__message.setProperty( "waitfor", _propertyInfo );
					__messages.add( __message );
				}
				// x = finish()
				Token x_next = new Token("finish_next");
				{
					Message __message = new Message( self, self.copy(), "finish", new Object[]{  }, token_3_0, x_next);
					__messages.add( __message );
				}
				x = x_next;
			}
		}
		start_time = System.currentTimeMillis();
	}
	public void local_start(String[] arguments) {
		int number_workers = Integer.parseInt(arguments[0]);
		int number_elements = Integer.parseInt(arguments[1]);
		int iterations = Integer.parseInt(arguments[2]);
		int elements_per_worker = number_elements/number_workers;
		Mergesort[] workers = new Mergesort[number_workers];
		for (int i = 0; i<number_workers; i++){
			workers[i] = Mergesort.construct(self, null, null, -1, new Object[]{}).copy();
		}
		Token x = new Token("x");
		{
			Token token_2_0 = new Token();
			// mergesort(new Integer(0), new Integer(number_workers), new Integer(elements_per_worker), workers)
			{
				Message __message = new Message( self, self.copy(), "mergesort", new Object[]{ new Integer(0), new Integer(number_workers), new Integer(elements_per_worker), workers }, null, token_2_0);
				__messages.add( __message );
			}
			// token x = finish()
			{
				Message __message = new Message( self, self.copy(), "finish", new Object[]{  }, token_2_0, x);
				__messages.add( __message );
			}
		}
		for (int i = 0; i<iterations-1; i++){
			{
				Token token_3_0 = new Token();
				// new Integer(0)new Integer(number_workers)new Integer(elements_per_worker)workersmergesort:((x))
				{
					Message __message = new Message( self, self.copy(), "mergesort", new Object[]{ new Integer(0), new Integer(number_workers), new Integer(elements_per_worker), workers }, null, token_3_0);
					Object[] _propertyInfo = { x };
					__message.setProperty( "waitfor", _propertyInfo );
					__messages.add( __message );
				}
				// x = finish()
				Token x_next = new Token("finish_next");
				{
					Message __message = new Message( self, self.copy(), "finish", new Object[]{  }, token_3_0, x_next);
					__messages.add( __message );
				}
				x = x_next;
			}
		}
		start_time = System.currentTimeMillis();
	}
	public double[] mergesort(int worker_num, int max_workers, int elements_per_worker, Mergesort[] workers) {
		if ((2*worker_num)+1<max_workers&&(2*worker_num)+2<max_workers) {
			Token x = new Token("x");
			{
				// token x = workers[(2*worker_num)+1]<-mergesort(new Integer((2*worker_num)+1), new Integer(max_workers), new Integer(elements_per_worker), workers)
				{
					Message __message = new Message( self, workers[(2*worker_num)+1], "mergesort", new Object[]{ new Integer((2*worker_num)+1), new Integer(max_workers), new Integer(elements_per_worker), workers }, null, x);
					__messages.add( __message );
				}
			}
			Token y = new Token("y");
			{
				// token y = workers[(2*worker_num)+2]<-mergesort(new Integer((2*worker_num)+2), new Integer(max_workers), new Integer(elements_per_worker), workers)
				{
					Message __message = new Message( self, workers[(2*worker_num)+2], "mergesort", new Object[]{ new Integer((2*worker_num)+2), new Integer(max_workers), new Integer(elements_per_worker), workers }, null, y);
					__messages.add( __message );
				}
			}
			{
				// merge(x, y)
				{
					Message __message = new Message( self, self.copy(), "merge", new Object[]{ x, y }, null, currentMessage.getContinuationToken());
					__message.setJoinPosition(currentMessage.getJoinPosition());
					__messages.add( __message );
				}
				throw new CurrentContinuationException();
			}
		}
		else if ((2*worker_num)+2<max_workers) {
			{
				// workers[(2*worker_num)+1]<-sort(new Integer(elements_per_worker))
				{
					Message __message = new Message( self, workers[(2*worker_num)+1], "sort", new Object[]{ new Integer(elements_per_worker) }, null, currentMessage.getContinuationToken());
					__message.setJoinPosition(currentMessage.getJoinPosition());
					__messages.add( __message );
				}
				throw new CurrentContinuationException();
			}
		}
		else {
			{
				// sort(new Integer(elements_per_worker))
				{
					Message __message = new Message( self, self.copy(), "sort", new Object[]{ new Integer(elements_per_worker) }, null, currentMessage.getContinuationToken());
					__message.setJoinPosition(currentMessage.getJoinPosition());
					__messages.add( __message );
				}
				throw new CurrentContinuationException();
			}
		}
	}
	public double[] merge(double[] x, double[] y) {
		int x_position = 0;
		int y_position = 0;
		double[] result = new double[x.length+y.length];
		for (int i = 0; i<result.length; i++){
			if (x_position>=x.length) {
				result[i] = y[y_position];
				y_position++;
			}
			else if (y_position>=y.length) {
				result[i] = x[x_position];
				x_position++;
			}
			else if (x[x_position]<y[y_position]) {
				result[i] = x[x_position];
				x_position++;
			}
			else {
				result[i] = y[y_position];
				y_position++;
			}
		}
		return result;
	}
	public double[] sort(int elements_per_worker) {
		double[] elements = new double[elements_per_worker];
		for (int j = 0; j<elements_per_worker; j++){
			elements[j] = Math.random();
		}
		for (int i = 0; i<elements.length; i++){
			for (int j = i; j<elements.length; j++){
				if (elements[j]<elements[i]) {
					double temp = elements[j];
					elements[j] = elements[i];
					elements[i] = temp;
				}
			}
		}
		return elements;
	}
	public void printResults(double[] results) {
		for (int i = 0; i<results.length; i++){
			System.err.println(results[i]);
		}
	}
	public void finish() {
		long finish_time = System.currentTimeMillis();
		System.err.println((finish_time-start_time));
		start_time = System.currentTimeMillis();
	}
}