package salsa_lite.examples.migration;

// Import declarations generated by the SALSA compiler, do not modify.
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import salsa_lite.core.language.Actor;
import salsa_lite.core.language.ActorReference;
import salsa_lite.core.language.IdentifierGenerator;
import salsa_lite.core.language.Message;
import salsa_lite.core.language.Token;
import salsa_lite.core.language.exceptions.CurrentContinuationException;
import salsa_lite.core.language.exceptions.MessageHandlerNotFoundException;

import salsa_lite.core.language.CollectibleActorState;

import salsa_lite.core.naming.UAN;
import salsa_lite.core.naming.UAL;
import salsa_lite.core.naming.MalformedUALException;
import salsa_lite.core.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.


public class LargeUniversalActorState extends CollectibleActorState  {
	public LargeUniversalActorState(UAN uan) {
		super(uan);
		self = new LargeUniversalActor(getUAN());
	}

	public LargeUniversalActorState(UAL ual) {
		super(ual);
		self = new LargeUniversalActor(getUAL());
	}

	public LargeUniversalActorState(String identifier) {
		super(identifier);
		self = new LargeUniversalActor(getUAL());
	}

	public Object invokeMessage(String methodName, Object[] arguments) throws CurrentContinuationException, MessageHandlerNotFoundException, Exception {
		if (methodName.equals("construct") && arguments.length == 0) {
			construct();
			return null;
		}  else if (methodName.equals("construct") && arguments.length == 1) {
			construct(((Integer)arguments[0]).intValue());
			return null;
		}  else if (methodName.equals("act") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof String[])) {
			act((String[])arguments[0]);
			return null;
		}  else {
			return super.invokeMessage(methodName, arguments);
		}
	}

	byte[] largeData;
	void construct(){
	}
	void construct(int size){
		largeData = new byte[size];
	}
	public void act(String args[]) {
		try {
			int howMany = Integer.parseInt(args[0]);
			int size = Integer.parseInt(args[1]);
			UAN uan = new UAN(args[2]);
			UAL ual = new UAL(args[3]);
			long initialTime = System.currentTimeMillis();
			for (int i = 0; i<howMany; i++){
				LargeUniversalActor a = LargeUniversalActor.construct(self, null, null, -1, new Object[]{size}).copy();
				{
					// a<-bind(uan, ual)
					{
						Message __message = new Message( self, a, "bind", new Object[]{ uan, ual }, null, null);
						__messages.add( __message );
					}
				}
			}
			long finalTime = System.currentTimeMillis();
			{
				// standardOutput<-println(howMany+" Large actor creations.  "+"Time taken (ms): "+(finalTime-initialTime))
				{
					Message __message = new Message( self, standardOutput, "println", new Object[]{ howMany+" Large actor creations.  "+"Time taken (ms): "+(finalTime-initialTime) }, null, null);
					__messages.add( __message );
				}
			}
		}
		catch (ArrayIndexOutOfBoundsException e) {
			{
				// standardOutput<-println("Usage: java migration.LargeUniversalActor "+"<howMany> <size> <UAN> <UAL>")
				{
					Message __message = new Message( self, standardOutput, "println", new Object[]{ "Usage: java migration.LargeUniversalActor "+"<howMany> <size> <UAN> <UAL>" }, null, null);
					__messages.add( __message );
				}
			}
		}
		catch (Exception e) {
			{
				// standardOutput<-println(e)
				{
					Message __message = new Message( self, standardOutput, "println", new Object[]{ e }, null, null);
					__messages.add( __message );
				}
			}
		}

	}
}