package salsa_lite.examples.migration;

// Import declarations generated by the SALSA compiler, do not modify.
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import salsa_lite.core.language.Actor;
import salsa_lite.core.language.ActorReference;
import salsa_lite.core.language.IdentifierGenerator;
import salsa_lite.core.language.Message;
import salsa_lite.core.language.Token;
import salsa_lite.core.language.exceptions.CurrentContinuationException;
import salsa_lite.core.language.exceptions.MessageHandlerNotFoundException;

import salsa_lite.core.language.CollectibleActorState;

import salsa_lite.core.naming.UAN;
import salsa_lite.core.naming.UAL;
import salsa_lite.core.naming.MalformedUALException;
import salsa_lite.core.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.


public class MigrateState extends CollectibleActorState  {
	public MigrateState(UAN uan) {
		super(uan);
		self = new Migrate(getUAN());
	}

	public MigrateState(UAL ual) {
		super(ual);
		self = new Migrate(getUAL());
	}

	public MigrateState(String identifier) {
		super(identifier);
		self = new Migrate(getUAL());
	}

	public Object invokeMessage(String methodName, Object[] arguments) throws CurrentContinuationException, MessageHandlerNotFoundException, Exception {
		if (methodName.equals("act") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof String[])) {
			act((String[])arguments[0]);
			return null;
		}  else if (methodName.equals("construct") && arguments.length == 0) {
			construct();
			return null;
		} else {
			return super.invokeMessage(methodName, arguments);
		}
	}

	void construct() {}

	public void act(String[] args) {
		try {
			Agent a = new Agent((new UAN(args[0]))).copy();
			{
				Token token_3_0 = new Token();
				Token token_3_1 = new Token();
				Token token_3_2 = new Token();
				// a<-addLocation(args[1])
				{
					Message __message = new Message( self, a, "addLocation", new Object[]{ args[1] }, null, token_3_0);
					__messages.add( __message );
				}
				// a<-migrate(args[1])
				{
					Message __message = new Message( self, a, "migrate", new Object[]{ args[1] }, token_3_0, token_3_1);
					__messages.add( __message );
				}
				// a<-printItinerary()
				{
					Message __message = new Message( self, a, "printItinerary", new Object[]{  }, token_3_1, token_3_2);
					__messages.add( __message );
				}
				// a<-printTime()
				{
					Message __message = new Message( self, a, "printTime", new Object[]{  }, token_3_2, null);
					__messages.add( __message );
				}
			}
		}
		catch (ArrayIndexOutOfBoundsException e) {
			{
				// standardOutput<-println("Usage: java migration.Migrate <uan> <UAL>")
				{
					Message __message = new Message( self, standardOutput, "println", new Object[]{ "Usage: java migration.Migrate <uan> <UAL>" }, null, null);
					__messages.add( __message );
				}
			}
			{
				// standardOutput<-println(e)
				{
					Message __message = new Message( self, standardOutput, "println", new Object[]{ e }, null, null);
					__messages.add( __message );
				}
			}
		}
		catch (MalformedUANException e) {
			{
				// standardError<-println("Error creating UAN: "+e)
				{
					Message __message = new Message( self, standardError, "println", new Object[]{ "Error creating UAN: "+e }, null, null);
					__messages.add( __message );
				}
			}
		}

	}
}