package examples.language;

// Import declarations generated by the SALSA compiler, do not modify.
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import salsa_lite.core.language.Actor;
import salsa_lite.core.language.ActorReference;
import salsa_lite.core.language.IdentifierGenerator;
import salsa_lite.core.language.Message;
import salsa_lite.core.language.Token;
import salsa_lite.core.language.exceptions.CurrentContinuationException;
import salsa_lite.core.language.exceptions.MessageHandlerNotFoundException;

import salsa_lite.core.language.CollectibleActorState;

import salsa_lite.core.naming.UAN;
import salsa_lite.core.naming.UAL;
import salsa_lite.core.naming.MalformedUALException;
import salsa_lite.core.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.


public class CurrentContinuationState extends CollectibleActorState  {
	public CurrentContinuationState(UAN uan) {
		super(uan);
		self = new CurrentContinuation(getUAN());
	}

	public CurrentContinuationState(UAL ual) {
		super(ual);
		self = new CurrentContinuation(getUAL());
	}

	public CurrentContinuationState(String identifier) {
		super(identifier);
		self = new CurrentContinuation(getUAL());
	}

	public Object invokeMessage(String methodName, Object[] arguments) throws CurrentContinuationException, MessageHandlerNotFoundException, Exception {
		if (methodName.equals("compute") && arguments.length == 0) {
			return new Integer(compute());
		}  else if (methodName.equals("add") && arguments.length == 2 && (arguments[0] == null || arguments[0] instanceof Integer) && (arguments[1] == null || arguments[1] instanceof Integer)) {
			return new Integer(add(((Integer)arguments[0]).intValue(), ((Integer)arguments[1]).intValue()));
		}  else if (methodName.equals("act") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof String[])) {
			act((String[])arguments[0]);
			return null;
		}  else if (methodName.equals("construct") && arguments.length == 0) {
			construct();
			return null;
		} else {
			return super.invokeMessage(methodName, arguments);
		}
	}

	void construct() {}

	public int compute() {
		{
			// add(4, 1)
			{
				Message __message = new Message( self, self.copy(), "add", new Object[]{ new Integer(4), new Integer(1) }, null, currentMessage.getContinuationToken());
				__message.setJoinPosition(currentMessage.getJoinPosition());
				__messages.add( __message );
			}
			throw new CurrentContinuationException();
		}
	}
	public int add(int n1, int n2) {
		return n1+n2;
	}
	public void act(String args[]) {
		{
			Token token_2_0 = new Token();
			// compute()
			{
				Message __message = new Message( self, self.copy(), "compute", new Object[]{  }, null, token_2_0);
				__messages.add( __message );
			}
			// standardOutput<-println(token)
			{
				Message __message = new Message( self, standardOutput, "println", new Object[]{ token_2_0 }, token_2_0, null);
				__messages.add( __message );
			}
		}
		{
			Token token_2_0 = new Token();
			Token token_2_1 = new Token();
			// compute()
			{
				Message __message = new Message( self, self.copy(), "compute", new Object[]{  }, null, token_2_0);
				__messages.add( __message );
			}
			// add(token, 2)
			{
				Message __message = new Message( self, self.copy(), "add", new Object[]{ token_2_0, new Integer(2) }, token_2_0, token_2_1);
				__messages.add( __message );
			}
			// standardOutput<-println(token)
			{
				Message __message = new Message( self, standardOutput, "println", new Object[]{ token_2_1 }, token_2_1, null);
				__messages.add( __message );
			}
		}
	}
}