package examples.language;

// Import declarations generated by the SALSA compiler, do not modify.
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import salsa_lite.core.language.Actor;
import salsa_lite.core.language.ActorReference;
import salsa_lite.core.language.IdentifierGenerator;
import salsa_lite.core.language.Message;
import salsa_lite.core.language.Token;
import salsa_lite.core.language.exceptions.CurrentContinuationException;
import salsa_lite.core.language.exceptions.MessageHandlerNotFoundException;

import salsa_lite.core.language.CollectibleActorState;

import salsa_lite.core.naming.UAN;
import salsa_lite.core.naming.UAL;
import salsa_lite.core.naming.MalformedUALException;
import salsa_lite.core.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.


public class TokenPrinterState extends CollectibleActorState  {
	public TokenPrinterState(UAN uan) {
		super(uan);
		self = new TokenPrinter(getUAN());
	}

	public TokenPrinterState(UAL ual) {
		super(ual);
		self = new TokenPrinter(getUAL());
	}

	public TokenPrinterState(String identifier) {
		super(identifier);
		self = new TokenPrinter(getUAL());
	}

	public Object invokeMessage(String methodName, Object[] arguments) throws CurrentContinuationException, MessageHandlerNotFoundException, Exception {
		if (methodName.equals("compute") && arguments.length == 0) {
			return new Integer(compute());
		}  else if (methodName.equals("computeString") && arguments.length == 0) {
			return computeString();
		}  else if (methodName.equals("computeObject") && arguments.length == 0) {
			return computeObject();
		}  else if (methodName.equals("print") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof Integer)) {
			print(((Integer)arguments[0]).intValue());
			return null;
		}  else if (methodName.equals("print") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof Integer)) {
			print((Integer)arguments[0]);
			return null;
		}  else if (methodName.equals("print") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof String)) {
			print((String)arguments[0]);
			return null;
		}  else if (methodName.equals("print") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof Object)) {
			print((Object)arguments[0]);
			return null;
		}  else if (methodName.equals("act") && arguments.length == 1 && (arguments[0] == null || arguments[0] instanceof String[])) {
			act((String[])arguments[0]);
			return null;
		}  else if (methodName.equals("construct") && arguments.length == 0) {
			construct();
			return null;
		} else {
			return super.invokeMessage(methodName, arguments);
		}
	}

	void construct() {}

	public int compute() {
		return 5;
	}
	public String computeString() {
		return "a string";
	}
	public Object computeObject() {
		return new Integer(5);
	}
	public void print(int number) {
		{
			// standardOutput<-println(new Integer(number+2))
			{
				Message __message = new Message( self, standardOutput, "println", new Object[]{ new Integer(number+2) }, null, null);
				__messages.add( __message );
			}
		}
	}
	public void print(Integer number) {
		{
			// standardOutput<-println(number)
			{
				Message __message = new Message( self, standardOutput, "println", new Object[]{ number }, null, null);
				__messages.add( __message );
			}
		}
	}
	public void print(String string) {
		{
			// standardOutput<-println(string+" indeed.")
			{
				Message __message = new Message( self, standardOutput, "println", new Object[]{ string+" indeed." }, null, null);
				__messages.add( __message );
			}
		}
	}
	public void print(Object object) {
		{
			// standardOutput<-println("Object:"+object)
			{
				Message __message = new Message( self, standardOutput, "println", new Object[]{ "Object:"+object }, null, null);
				__messages.add( __message );
			}
		}
	}
	public void act(String[] args) {
		{
			Token token_2_0 = new Token();
			// compute()
			{
				Message __message = new Message( self, self.copy(), "compute", new Object[]{  }, null, token_2_0);
				__messages.add( __message );
			}
			// print(token)
			{
				Message __message = new Message( self, self.copy(), "print", new Object[]{ token_2_0 }, token_2_0, null);
				__messages.add( __message );
			}
		}
		{
			Token token_2_0 = new Token();
			// computeString()
			{
				Message __message = new Message( self, self.copy(), "computeString", new Object[]{  }, null, token_2_0);
				__messages.add( __message );
			}
			// print(token)
			{
				Message __message = new Message( self, self.copy(), "print", new Object[]{ token_2_0 }, token_2_0, null);
				__messages.add( __message );
			}
		}
		{
			Token token_2_0 = new Token();
			// computeObject()
			{
				Message __message = new Message( self, self.copy(), "computeObject", new Object[]{  }, null, token_2_0);
				__messages.add( __message );
			}
			// print(token)
			{
				Message __message = new Message( self, self.copy(), "print", new Object[]{ token_2_0 }, token_2_0, null);
				__messages.add( __message );
			}
		}
		int i = 0;
		String s = "s";
		{
			Token token_2_0 = new Token();
			Token token_2_1 = new Token();
			Token token_2_2 = new Token();
			Token token_2_3 = new Token();
			// print(1)
			{
				Message __message = new Message( self, self.copy(), "print", new Object[]{ new Integer(1) }, null, token_2_0);
				__messages.add( __message );
			}
			// print(s)
			{
				Message __message = new Message( self, self.copy(), "print", new Object[]{ s }, token_2_0, token_2_1);
				__messages.add( __message );
			}
			// print("a"+"b")
			{
				Message __message = new Message( self, self.copy(), "print", new Object[]{ "a"+"b" }, token_2_1, token_2_2);
				__messages.add( __message );
			}
			// print(new Integer(1))
			{
				Message __message = new Message( self, self.copy(), "print", new Object[]{ new Integer(1) }, token_2_2, token_2_3);
				__messages.add( __message );
			}
			// print(new Integer(1+1))
			{
				Message __message = new Message( self, self.copy(), "print", new Object[]{ new Integer(1+1) }, token_2_3, null);
				__messages.add( __message );
			}
		}
	}
}