/*
 *
 */

package salsa_lite.wwc.transport;

import salsa_lite.core.language.Actor;
import salsa_lite.core.language.Message;
import salsa_lite.core.services.TransportService;

/**
 * This class is the reference implementation of the Persistent MessagingService. The
 * service is implemented as a RMSP client.
 *
 * This implementation uses the NamingService interface and the salsa.language.
 * ServiceFactory for UAN resolution.
 *
 * @authors Travis Desell, Kaoutar El Maghraoui
 */

public class WWCTransportService implements TransportService {
	/********
		*
	 ********/
	int number_actors = 1;
	TransportActor[] transportActors;

	public WWCTransportService() {
		if (System.getProperty("tsthreads") != null) {
			number_actors = Integer.parseInt( System.getProperty("tsthreads") );
		}
		transportActors = new TransportActor[number_actors];
		for (int i = 0; i < number_actors; i++) {
			transportActors[i] = new TransportActor(i);
			transportActors[i].start();
		}
	}

	private int getTarget(int hashcode) {
		return Math.abs(hashcode % number_actors);
	}

	public void transfer(Object object, String targetHost, int targetPort) {
		int target = getTarget(object.hashCode());
		transportActors[target].put( new SendObjectMessage(object, targetHost, targetPort) );
	}
}
